function modeswitch_M3d(handles)
%
%MODESWITCH_M3D
%
%       Switch UI control visibility to the 3D mode and set titles, 
%       then call update_M3d to update the control position/contents.
%

global pvoxM3d PguiData Ptoolbar Phandles pvoxM1d;

if ~ nargin
    handles=Phandles;
end

% Determine Previous mode and set menus/view appropriately
switch PguiData.mode
    case 'M1d'
        set(handles.menu_1d,'Checked','off');
        set(Ptoolbar.M1d,'State','off');
        if (~pvoxM1d.atomview)
            view(PguiData.az, PguiData.el);
        end
    case 'M2d'
        set(handles.menu_2d,'Checked','off');
        set(Ptoolbar.M2d,'State','off');
        %click_reset;
        view(PguiData.az, PguiData.el);
    case 'M3d'
        set(handles.menu_3d,'Checked','on');
        set(Ptoolbar.M3d,'State','on');
        return;
    case 'Mdos'
        set(handles.menu_dos,'Checked','off');
        set(Ptoolbar.Mdos,'State','off');
        view(PguiData.az, PguiData.el);
    case 'Mslice'
        set(handles.menu_slice,'Checked','off');
        set(Ptoolbar.Mslice,'State','off');
end

PguiData.mode = 'M3d';
set(handles.menu_3d,'Checked','on');
set(Ptoolbar.M3d,'State','on');

xlabel('');
title('');

%
%change layout data
%
%TODO: change size data
%

set(handles.pulldown_left,'Visible','off');
set(handles.pulldown_right,'Visible','off');

set(handles.slider_h_middle,'Visible','off');
set(handles.slider_h_bottom,'Visible','off');
set(handles.text_h_middle,'Visible','off');
set(handles.text_h_bottom,'Visible','off');

%energy level and energy of level
if strncmp(PguiData.graph,'wfn',3)

    set(handles.slider_h_top,'Visible','on');
    set(handles.text_h_top,'Visible','on');
    set(handles.text_left,'Visible','on');
    set(handles.edit_left,'Visible','on');
    set(handles.text_right,'Visible','on');
    set(handles.edit_right,'Visible','on');

    set(handles.text_left,'String','Energy (eV)');
    set(handles.text_right,'String','Level');
    set(handles.text_h_top,'String','Level');

else

    set(handles.slider_h_top,'Visible','off');
    set(handles.text_h_top,'Visible','off');
    set(handles.text_left,'Visible','off');
    set(handles.edit_left,'Visible','off');
    set(handles.text_right,'Visible','off');
    set(handles.edit_right,'Visible','off');

end

set(handles.edit_left,'BackgroundColor',[.824 .824 .824]);
set(handles.edit_right,'BackgroundColor',[1 1 1]);

%color toggle
set(handles.togglebutton_top,'Visible','on');
set(handles.togglebutton_middle,'Visible','on');
set(handles.togglebutton_bottom,'Visible','off');

set(handles.togglebutton_top,'String','contour');
set(handles.togglebutton_middle,'String','color');

set(handles.togglebutton_middle,'BackgroundColor',[.702 .702 .702]);
set(handles.togglebutton_middle,'Style','togglebutton');
set(handles.togglebutton_top,'Style','togglebutton');

set(handles.togglebutton_middle,'FontWeight','bold');

set(handles.slider_v,'Visible','off');

%num slices
set(handles.text_top,'Visible','on');
set(handles.edit_top,'Visible','on');
set(handles.text_top,'String','Num Slices');
set(handles.edit_top,'BackgroundColor',[1 1 1]);

%menu stuff
set(handles.menu_pot,'Enable','on');
set(handles.menu_rho,'Enable','on');
set(handles.menu_wfn,'Enable','on');
set(handles.menu_atoms,'Enable','on');

set(Ptoolbar.pot,'Enable','on');
set(Ptoolbar.rho,'Enable','on');
set(Ptoolbar.wfn,'Enable','on');
set(Ptoolbar.atoms,'Enable','on');
set(Ptoolbar.rotate,'Enable','on');
set(Ptoolbar.colorbar,'Enable','on');
set(Ptoolbar.zoomin,'Enable','on');
set(Ptoolbar.reset,'Enable','on');

if PguiData.atoms
    set(handles.menu_atoms,'Checked','on');
    set(Ptoolbar.atoms,'State','on');
else
    set(handles.menu_atoms,'Checked','off');
    set(Ptoolbar.atoms,'State','off');
end

%
%REGRAPH
%
%UPDATE SLIDERS, TEXTS, AND EDITS
%

if ~(pvoxM3d.init)
    M3d_init;
end

update_M3d('everything');
