function modeswitch_Mdos(handles)
%
%MODESWITCH_MDOS
%
%       Switch UI control visibility to the Density of States mode and 
%       set titles, then call update_Mdos to update the control 
%       position/contents.
%
%

global pvoxMdos PguiData Ptoolbar Phandles pvoxM1d;

if ~ nargin
    handles=Phandles;
end

% Determine Previous mode and set menus/view appropriately
switch PguiData.mode
    case 'M1d'
        set(handles.menu_1d,'Checked','off');
        set(Ptoolbar.M1d,'State','off');
        if (pvoxM1d.atomview)
            [PguiData.az, PguiData.el] = view;
        end
    case 'M2d'
        set(handles.menu_2d,'Checked','off');
        set(Ptoolbar.M2d,'State','off');
        %click_reset;
    case 'M3d'
        set(handles.menu_3d,'Checked','off');
        set(Ptoolbar.M3d,'State','off');
        [PguiData.az, PguiData.el] = view;
    case 'Mdos'
        set(handles.menu_dos,'Checked','on');
        set(Ptoolbar.Mdos,'State','on');
        return;
    case 'Mslice'
        set(handles.menu_slice,'Checked','off');
        set(Ptoolbar.Mslice,'State','off');
        [PguiData.az, PguiData.el] = view;
end

PguiData.mode = 'Mdos';
set(handles.menu_dos,'Checked','on');
set(Ptoolbar.Mdos,'State','on');

%
%change layout data
%
%TODO: change size data
%

set(handles.pulldown_left,'Visible','off');
set(handles.pulldown_right,'Visible','off');

set(handles.slider_h_middle,'Visible','off');
set(handles.slider_h_bottom,'Visible','off');
set(handles.text_h_middle,'Visible','off');
set(handles.text_h_bottom,'Visible','off');

set(handles.slider_h_top,'Visible','on');
set(handles.text_h_top,'Visible','on');

set(handles.text_left,'Visible','on');
set(handles.edit_left,'Visible','on');
set(handles.text_right,'Visible','on');
set(handles.edit_right,'Visible','on');

set(handles.edit_left,'BackgroundColor',[1 1 1]);
set(handles.edit_right,'BackgroundColor',[1 1 1]);

set(handles.text_left,'String','Width Param');
set(handles.text_right,'String','Iteration');
set(handles.text_h_top,'String','Iteration');

set(handles.togglebutton_bottom,'Visible','off');

set(handles.togglebutton_top,'Visible', 'on');
set(handles.togglebutton_top,'String','Integral');


set(handles.togglebutton_middle,'BackgroundColor',[.702 .702 .702]);
set(handles.togglebutton_middle,'Style','togglebutton');
set(handles.togglebutton_middle,'Visible','on');
set(handles.togglebutton_middle,'String','Occupied');

set(handles.slider_v,'Visible','off');
set(handles.text_top,'Visible','off');
set(handles.edit_top,'Visible','off');

%menu stuff
set(handles.menu_pot,'Enable','off');
set(handles.menu_rho,'Enable','off');
set(handles.menu_wfn,'Enable','off');
set(handles.menu_atoms,'Enable','off');

set(Ptoolbar.pot,'Enable','off');
set(Ptoolbar.rho,'Enable','off');
set(Ptoolbar.wfn,'Enable','off');
set(Ptoolbar.atoms,'Enable','off');
set(Ptoolbar.rotate,'Enable','off');
set(Ptoolbar.colorbar,'Enable','off');
%set(Ptoolbar.zoomin,'Enable','off');
%set(Ptoolbar.reset,'Enable','off');
set(Ptoolbar.zoomin,'Enable','on');
set(Ptoolbar.reset,'Enable','on');

%
%REGRAPH
%
%UPDATE SLIDERS, TEXTS, AND EDITS
%

if ~(pvoxMdos.init)
    Mdos_init;
end

zoom(handles.axes1,'off');

update_Mdos('everything');
