function click_atom(varargin)
%
%CLICK_ATOM
%
%       Update the PguiData.atoms to reflect whether the atoms are to be
%       plotted or not, then replot axes if appropriate.
%

global PguiData Phandles Ptoolbar;

%update menu
if strncmp( (get(Phandles.menu_atoms,'Checked')), 'on',2)
    
    PguiData.atoms=0;
    set(Phandles.menu_atoms,'Checked','off')
    
else
    
    PguiData.atoms=1;
    set(Phandles.menu_atoms,'Checked','on')
    
end

%if appropriate, regraph
switch PguiData.mode
    case 'M3d'
        update_M3d('atoms',PguiData.atoms);
    case 'Mslice'
        update_Mslice('atoms',PguiData.atoms);
    otherwise
end
