function graphswitch_wfn(handles)
%
%GRAPHSWITCH_WFN
%
%       Switch the GUI so that the controls for the wavefunction graph are
%       available. Then call the update_<mode> function to update controls
%       and axes.
%
%


global PguiData Phandles Ptoolbar;

%if strncmp( PguiData.graph,'wfn',3 )
%    return;
%end

if ~ nargin
    handles=Phandles;
end

PguiData.graph = 'wfn';
set(handles.menu_pot,'Checked','off');
set(handles.menu_rho,'Checked','off');
set(handles.menu_wfn,'Checked','on');

set(Ptoolbar.wfn,'State','on');
set(Ptoolbar.pot,'State','off');
set(Ptoolbar.rho,'State','off');

switch PguiData.mode
    case 'M1d'

        %energy level and energy of level
        set(handles.slider_v,'Visible','on');
        set(handles.text_top,'Visible','on');
        set(handles.edit_top,'Visible','on');

        set(handles.text_top,'String','Level');
        
        %update texts et al
        update_M1d('wfn');

    case 'M2d'

        %energy level and energy of level
        set(handles.slider_h_top,'Visible','on');
        set(handles.text_h_top,'Visible','on');
        set(handles.text_left,'Visible','on');
        set(handles.edit_left,'Visible','on');
        set(handles.text_right,'Visible','on');
        set(handles.edit_right,'Visible','on');

        set(handles.text_h_top,'String','Level');
        set(handles.text_left,'String','Energy (eV)');
        set(handles.text_right,'String','Level');

        %update texts et al
        update_M2d('wfn');

    case 'M3d'

        %energy level and energy of level
        set(handles.slider_h_top,'Visible','on');
        set(handles.text_h_top,'Visible','on');
        set(handles.text_left,'Visible','on');
        set(handles.edit_left,'Visible','on');
        set(handles.text_right,'Visible','on');
        set(handles.edit_right,'Visible','on');

        set(handles.text_h_top,'String','Level');
        set(handles.text_left,'String','Energy (eV)');
        set(handles.text_right,'String','Level');

        %update texts et al
        update_M3d('wfn');

    case 'Mslice'

        %energy level and energy of level
        set(handles.slider_v,'Visible','on');
        set(handles.text_top,'Visible','on');
        set(handles.edit_top,'Visible','on');

        set(handles.text_top,'String','Level');

        set(handles.togglebutton_top,'Visible','on');
        set(handles.togglebutton_middle,'Visible','on');
        set(handles.togglebutton_bottom,'Visible','off');
        set(handles.togglebutton_top,'String','Energy (eV)');

        %update texts et al
        update_Mslice('wfn');

end
