function varargout = prefs(varargin)
    % prefs M-file for prefs.fig
    %      prefs, by itself, creates a new prefs or raises the existing
    %      singleton*.
    %
    %      H = prefs returns the handle to a new prefs or the handle to
    %      the existing singleton*.
    %
    %      prefs('CALLBACK',hObject,eventData,handles,...) calls the local
    %      function named CALLBACK in prefs.M with the given input arguments.
    %
    %      prefs('Property','Value',...) creates a new prefs or raises the
    %      existing singleton*.  Starting from the left, property value pairs are
    %      applied to the GUI before prefs_OpeningFunction gets called.  An
    %      unrecognized property name or invalid value makes property application
    %      stop.  All inputs are passed to prefs_OpeningFcn via varargin.
    %
    %      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
    %      instance to run (singleton)".
    %
    % See also: GUIDE, GUIDATA, GUIHANDLES

    % Edit the above text to modify the response to help prefs

    % Last Modified by GUIDE v2.5 10-Aug-2005 15:36:52

    % Begin initialization code - DO NOT EDIT
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
        'gui_Singleton',  gui_Singleton, ...
        'gui_OpeningFcn', @prefs_OpeningFcn, ...
        'gui_OutputFcn',  @prefs_OutputFcn, ...
        'gui_LayoutFcn',  [] , ...
        'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
    % End initialization code - DO NOT EDIT


    % --- Executes just before prefs is made visible.
function prefs_OpeningFcn(hObject, eventdata, handles, varargin)
    % This function has no output args, see OutputFcn.
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    % varargin   command line arguments to prefs (see VARARGIN)

    % Choose default command line output for prefs
    handles.output = hObject;

    % Update handles structure
    guidata(hObject, handles);

    % UIWAIT makes prefs wait for user response (see UIRESUME)
    % uiwait(handles.prefs);
    
    global pvoxView;
    pvoxView.pref = handles;
    
    global PguiData ParsecData pref par val;
    
    pref.message = 0;
    pref.editmessage = 0;
    
    val = 0;
    pref.newcolor = ParsecData.typeColor;
    pref.newsize = ParsecData.typeSize;
    par = varargin{1};
    pref.map = {'default'; 'autumn'; 'bone'; 'cool'; 'copper'; 'gray'; 'hot'; 'hsv'; 'jet';'spring'; 'summer'; 'winter'};
    pref.map_invert = PguiData.colormap_invert;
    pref.grid = {'on'; 'off'};
    pref.grid_val = 1-PguiData.gridlines+1;
    for (i = 1:size(pref.map))
        if strcmp(pref.map{i}, PguiData.colormap)
            pref.map_val = i;
        end
    end
    pref.contours = PguiData.contour_levels;
    pref.draw_mode = {'normal'; 'fast'};
    pref.draw_val = PguiData.draw_mode;
    pref.wfn_color = {'Universal'; 'Individual'};
    pref.wfn_colorval = 2-PguiData.wfn_universal;
    %PguiData.
    update_prefs(handles)


    % --- Outputs from this function are returned to the command line.
function varargout = prefs_OutputFcn(hObject, eventdata, handles)
    % varargout  cell array for returning output args (see VARARGOUT);
    % hObject    handle to figure
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get default command line output from handles structure
    varargout{1} = handles.output;


    % --- Executes on selection change in list.
function list_Callback(hObject, eventdata, handles)
    % hObject    handle to list (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: contents = get(hObject,'String') returns list contents as cell array
    %        contents{get(hObject,'Value')} returns selected item from list


    % --- Executes during object creation, after setting all properties.
function list_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to list (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: listbox controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    global ParsecData val;
    val = 1;
    %update_prefs(handles);
    names = ParsecData.typeName;
    set(hObject, 'String', names, 'Value', 1);


    % --- Executes on button press in push_choose.
function push_choose_Callback(hObject, eventdata, handles)
    % hObject    handle to push_choose (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Get the atom to be changed
    global ParsecData pref val;
    set(handles.text, 'Enable', 'inactive');
    set(handles.push_left, 'Enable', 'inactive');
    set(handles.push_right, 'Enable', 'inactive');
    set(handles.push_choose, 'Enable', 'inactive');
    set(handles.push_apply, 'Enable', 'inactive');
    set(handles.push_OK, 'Enable', 'inactive');
    set(handles.push_cancel, 'Enable', 'inactive');
    pref.editmessage = 1;
    drawnow;
    if ( val == 0 )
        list_entries = get(handles.list,'String');
        index_selected = get(handles.list,'Value');

        siz = pref.newsize(index_selected);
        check = inputdlg('Input radius', ParsecData.typeName(index_selected), 1, {mat2str(pref.newsize(index_selected))})
        
        try
            check = str2double(check)%str2double(inputdlg('Input radius', ParsecData.typeName(index_selected), 1, {mat2str(pref.newsize(index_selected))}))
            %catch
            %return;
        end
        
        %if pvox is closed exit gracefully
        global pvoxView;
        if pvoxView.closed
            return;
        end
        
        if ( max(size(check)) == 1 && (isnumeric(check)) && ~isnan(check) && isreal(check))
            pref.newsize(index_selected) = check;
        end

    elseif ( val == 1 )
        list_entries = get(handles.list,'String');
        index_selected = get(handles.list,'Value');
        color = pref.newcolor(index_selected,:);
        set(handles.text, 'Enable', 'inactive');
        pref.newcolor(index_selected,:) = uisetcolor(color, 'Choose a Color');

        %if pvox is closed exit gracefully
        global pvoxView
        if pvoxView.closed
            return;
        end
        
    elseif ( val == 2 )
        pref.map_invert = 1 - pref.map_invert;
        if ( pref.map_invert )
            set(handles.push_choose, 'Visible', 'on', 'String', 'Invert: On');%'String', 'Custom Colormap');
        else
            set(handles.push_choose, 'Visible', 'on', 'String', 'Invert: Off');%'String', 'Custom Colormap');
        end
    elseif ( val == 4 )
        pref.contours = [.95 .75 .25];
        set(handles.list, 'String', pref.contours, 'Value', 1);
    end
    set(handles.text, 'Enable', 'on');
    set(handles.push_left, 'Enable', 'on');
    set(handles.push_right, 'Enable', 'on');
    set(handles.push_choose, 'Enable', 'on');
    set(handles.push_apply, 'Enable', 'on');
    set(handles.push_OK, 'Enable', 'on');
    set(handles.push_cancel, 'Enable', 'on');
    pref.editmessage = 0;
    drawnow;
    % --- Executes on button press in push_cancel.
function push_cancel_Callback(hObject, eventdata, handles)
    % hObject    handle to push_cancel (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    close(handles.prefs);

    % --- Executes on button press in push_OK.
function push_OK_Callback(hObject, eventdata, handles)
    % hObject    handle to push_OK (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    apply(handles);
    close(handles.prefs);

function apply(handles)
    % What actually keeps the changes
    global PguiData ParsecData pref par val;
    if ( val == 2 )
        pref.map_val = get(handles.list, 'Value');
    end
    if ( val == 3 )
        pref.grid_val = get(handles.list, 'Value');
    end
    if ( val == 5 )
        pref.draw_val = get(handles.list, 'Value');
    end
    if ( val == 6 )
        pref.wfn_colorval = get(handles.list, 'Value');
    end
    % Size of the atoms
    ParsecData.typeSize = pref.newsize;
    % Colors of the atoms
    ParsecData.typeColor = pref.newcolor;
    % The new colormap
    PguiData.colormap = pref.map{pref.map_val,:};
    PguiData.colormap_invert = pref.map_invert;
    % The gridlines
    PguiData.gridlines = -1*(pref.grid_val-2);
    % The contours
    PguiData.contour_levels = pref.contours;
    % The draw mode
    PguiData.draw_mode = pref.draw_val;
    if ( pref.draw_val == 1 )
        set(par.axes1, 'DrawMode', 'normal');
    else
        set(par.axes1, 'DrawMode', 'fast');
    end
    % The universal
    PguiData.wfn_universal = 2-pref.wfn_colorval;
        
    
    update_gui(par);
        
    

    % --- Executes on button press in push_apply.
function push_apply_Callback(hObject, eventdata, handles)
    % hObject    handle to push_apply (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    apply(handles);


    % --- Executes on button press in push_left.
function push_left_Callback(hObject, eventdata, handles)
    % hObject    handle to push_left (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    global val pref;

    % Update preferences
    if ( val == 2 )
        pref.map = get(handles.list, 'String');
        pref.map_val = get(handles.list, 'Value');
    end
    if ( val == 3 )
        pref.grid_val = get(handles.list, 'Value');
    end
    if ( val == 5 )
        pref.draw_val = get(handles.list, 'Value');
    end
    if ( val == 6 )
        pref.wfn_colorval = get(handles.list, 'Value');
    end

    if ( val > 0 )
        val = val - 1;
        update_prefs(handles);
    else
        val = 6;
        update_prefs(handles);
    end

    % --- Executes on button press in push_right.
function push_right_Callback(hObject, eventdata, handles)
    % hObject    handle to push_right (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    global val pref;
    
    % Update preferences
    if ( val == 2 )
        pref.map = get(handles.list, 'String');
        pref.map_val = get(handles.list, 'Value');
    end
    if ( val == 3 )
        pref.grid_val = get(handles.list, 'Value');
    end
    if ( val == 5 )
        pref.draw_val = get(handles.list, 'Value');
    end
    if ( val == 6 )
        pref.wfn_colorval = get(handles.list, 'Value');
    end

    if ( val < 6 )
        val = val + 1;
        update_prefs(handles);
    else
        val = 0;
        update_prefs(handles);
    end

    % UPDATE THE PREFERENCES WINDOW TO REFLECT A NEW PREFERENCE BEING ACCESSED
function update_prefs(handles)
    global val ParsecData pref;
    switch ( val )
        case 0
            names = ParsecData.typeName;
            set(handles.list, 'String', names, 'Value', 1);
            set(handles.text, 'Value', 1);
            set(handles.push_choose, 'Visible', 'on', 'String', 'Choose Size');
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');
        
        case 1
            % Atom color chooser
            names = ParsecData.typeName;
            set(handles.list, 'String', names, 'Value', 1);
            set(handles.text, 'Value', 2);
            set(handles.push_choose, 'Visible', 'on', 'String', 'Choose Color');
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');

        case 2
            % Colormap chooser
            names = pref.map;
            set(handles.list, 'String', names, 'Value', pref.map_val);
            set(handles.text, 'Value', 3);
            if ( pref.map_invert )
                set(handles.push_choose, 'Visible', 'on', 'String', 'Invert: On');
            else
                set(handles.push_choose, 'Visible', 'on', 'String', 'Invert: Off');
            end
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');

        case 3
            % Gridline chooser
            names = pref.grid;
            set(handles.list, 'String', names, 'Value', pref.grid_val);
            set(handles.text, 'Value', 4);
            set(handles.push_choose, 'Visible', 'off');
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');

        case 4
            % Contour locations
            names = pref.contours;
            set(handles.list, 'String', names, 'Value', 1);
            set(handles.text, 'Value', 5);
            set(handles.push_choose, 'Visible', 'on', 'String', 'Default');
            set(handles.push_add, 'Visible', 'on');
            set(handles.push_remove, 'Visible', 'on');
            
        case 5
            % Draw Mode
            names = pref.draw_mode;
            set(handles.list, 'String', names, 'Value', pref.draw_val);
            set(handles.text, 'Value', 6);
            set(handles.push_choose, 'Visible', 'off');
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');
            
        case 6
            % Wave Function Colormode
            names = pref.wfn_color;
            set(handles.list, 'String', names, 'Value', pref.wfn_colorval);
            set(handles.text, 'Value', 7);
            set(handles.push_choose, 'Visible', 'off');
            set(handles.push_add, 'Visible', 'off');
            set(handles.push_remove, 'Visible', 'off');
    end


    % --- Executes on button press in push_add.
function push_add_Callback(hObject, eventdata, handles)
    % hObject    handle to push_add (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    
    global pref;
    set(handles.text, 'Enable', 'inactive');
    set(handles.push_left, 'Enable', 'inactive');
    set(handles.push_right, 'Enable', 'inactive');
    set(handles.push_choose, 'Enable', 'inactive');
    set(handles.push_apply, 'Enable', 'inactive');
    set(handles.push_OK, 'Enable', 'inactive');
    set(handles.push_cancel, 'Enable', 'inactive');
    set(handles.push_add, 'Enable', 'inactive');
    set(handles.push_remove, 'Enable', 'inactive');
    pref.editmessage = 1;
    
    drawnow;
    newlevel = inputdlg('Input a value from 0 - 1:', 'New Contour Level');
    
    
    %if pvox is closed exit gracefully
    global pvoxView;
    if pvoxView.closed
        return;
    end
    
    try
        newlevel = str2double(newlevel);
    end

    con = [];
    if ( size(newlevel) == [1 1] )
        if ( (isnumeric(newlevel) == 1) && (max(isnan(newlevel)) == 0) && (newlevel >= 0) && (newlevel <= 1) )
            % Set a contour level to be this
            s = size(pref.contours);
            j = 1;
            for ( i = 1:s(2) )
                if ( pref.contours(i) > newlevel )
                    con = [con pref.contours(i)];
                    j = i+1;
                elseif (pref.contours(i) == newlevel)
                    return;
                end
            end
            con = [con, newlevel];
            for ( i = j:s(2) )
                con = [con pref.contours(i)];
            end

            pref.contours = con;
            update_prefs(handles);
        end
    end
    set(handles.text, 'Enable', 'on');
    set(handles.push_left, 'Enable', 'on');
    set(handles.push_right, 'Enable', 'on');
    set(handles.push_choose, 'Enable', 'on');
    set(handles.push_apply, 'Enable', 'on');
    set(handles.push_OK, 'Enable', 'on');
    set(handles.push_cancel, 'Enable', 'on');
    set(handles.push_add, 'Enable', 'on');
    set(handles.push_remove, 'Enable', 'on');
    pref.editmessage = 0;
    drawnow;

    % --- Executes on button press in push_remove.
function push_remove_Callback(hObject, eventdata, handles)
    % hObject    handle to push_remove (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
    global val pref;
    if ( val == 4 )
        num = get(handles.list, 'Value');
        a = [];
        s = size(pref.contours);
        for ( i = 1:s(2))
            if ( i ~= num )
                a = [a pref.contours(i)];
            end
        end
        pref.contours = a;
        set(handles.list, 'String', pref.contours, 'Value', 1);
    end


    % --- Executes during object creation, after setting all properties.
function text_CreateFcn(hObject, eventdata, handles)
    % hObject    handle to text (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    empty - handles not created until after all CreateFcns called

    % Hint: popupmenu controls usually have a white background on Windows.
    %       See ISPC and COMPUTER.
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    set(hObject, 'String', {'Atom Radius' 'Atom Colors' 'Current Colormap' 'Show Gridlines?' 'Edit Contour Values' 'Draw Mode' 'WFN Scaling'});


    % --- Executes on selection change in text.
function text_Callback(hObject, eventdata, handles)
    % hObject    handle to text (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)

    % Hints: contents = get(hObject,'String') returns text contents as cell array
    %        contents{get(hObject,'Value')} returns selected item from text
    global val pref;
    if ( val == 2 )
        pref.map = get(handles.list, 'String');
        pref.map_val = get(handles.list, 'Value');
    end
    if ( val == 3 )
        pref.grid_val = get(handles.list, 'Value');
    end
    val = get(hObject, 'Value') - 1;
    update_prefs(handles);

% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over text.
function text_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in push_help.
function push_help_Callback(hObject, eventdata, handles)
% hObject    handle to push_help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global val ParsecData pref;
if ( pref.message == 0 )
    pref.message = 1;
    switch ( val )
        case 0
            % Atom radius chooser
            pref.message = msgbox('Atom Radius: Choose an atom from the list and click "Choose Size" to enter in the new size of the atom.', 'Help', 'help');
           
        case 1
            % Atom color chooser
            pref.message = msgbox('Atom Colors: Choose an atom from the list and click "Choose Color" to enter in the new color of the atom.', 'Help', 'help');

        case 2
            % Colormap chooser
            pref.message = msgbox('Current Colormap: Choose the colormap with which to draw the functions.', 'Help', 'help');

        case 3
            % Gridline chooser
            pref.message = msgbox('Gridlines: If you select on, PVOX will draw gridlines on all surfaces and atoms.  If you select off PVOX will omit the gridlines.', 'Help', 'help');

        case 4
            % Contour locations
            pref.message = msgbox('Contour Values: This applies to the 3D contour plot.  The contour values refer to a percent of the function.  A lower value will create contours in lower areas, a higher value gives higher contours.  Click "+" to add a new contour level (between 0 and 1) to draw, or select a value from the list and click "-" to remove that level.  Return to the default values by clicking "Default".', 'Help', 'help');

        case 5
            % Draw Mode
            pref.message = msgbox('Draw Mode: Choosing fast will speed up the rate at which the graphing, rotating, and zooming take place, but the graph may lose some quality.', 'Help', 'help');

        case 6
            % WFN Scaling
            pref.message = msgbox('Wave Function (WFN) Scaling: Choosing the universal scaling method will keep the color and axes limits the same when changing between levels (i.e. the same color always corresponds to the same value).  Choosing individual will cause the program to recalculate the limits when levels are changed. ', 'Help', 'help');
            
    end
    set(pref.message, 'DeleteFcn', 'messageClose');
end

% --- Executes when user attempts to close prefs.
function prefs_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to prefs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure

global pref;

try
    delete(pref.message);
end

if ( pref.editmessage == 0 )
    delete(hObject);
else
    beep;
end


% --- Executes during object creation, after setting all properties.
function push_help_CreateFcn(hObject, eventdata, handles)
% hObject    handle to push_help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set(hObject,'String','');
set(hObject,'CData', imread('./pTools/pGUI/Toolbar/help.bmp') );

